Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTLinkageSpecification

All Superinterfaces:
  `IASTDeclaration`, `IASTDeclarationListOwner`, `IASTNode`

public interface ICPPASTLinkageSpecification extends IASTDeclaration, IASTDeclarationListOwner
This interface represents a linkage specification. e.g. extern "C" { ... }

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`OWNED_DECLARATION`
`OWNED_DECLARATION` is the owned declaration role for linkages.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclaration

`EMPTY_DECLARATION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`void`
`addDeclaration(IASTDeclaration declaration)`
Adds another declaration to the linkage.
`ICPPASTLinkageSpecification`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTLinkageSpecification`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTDeclaration[]`
`getDeclarations()`
Returns all of the declarations.
`String`
`getLiteral()`
Returns the "literal" that represents the linkage.
`void`
`setLiteral(String value)`
Sets the "literal" that represents the linkage.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclarationListOwner

`getDeclarations`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### OWNED_DECLARATION

static final ASTNodeProperty OWNED_DECLARATION
`OWNED_DECLARATION` is the owned declaration role for linkages.

## Method Details

### getLiteral

String getLiteral()
Returns the "literal" that represents the linkage.

Returns:
  String

### setLiteral

void setLiteral(String value)
Sets the "literal" that represents the linkage.

Parameters:
  `value` - the "literal" that represents the linkage

### getDeclarations

IASTDeclaration[] getDeclarations()
Returns all of the declarations.

Returns:
  `IASTDeclaration[]`

### addDeclaration

void addDeclaration(IASTDeclaration declaration)
Adds another declaration to the linkage.

Specified by:
  `addDeclaration` in interface `IASTDeclarationListOwner`
Parameters:
  `declaration` - the declaration to add

### copy

ICPPASTLinkageSpecification copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

ICPPASTLinkageSpecification copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3